/*
Copyright (C) 2000-2004  The PARI group.

This file is part of the PARI/GP package.

PARI/GP is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation. It is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY WHATSOEVER.

Check the License for details. You should have received a copy of it, along
with the package; see the file 'COPYING'. If not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */


int debug;

typedef enum {Gvoid, Gnegbool, Gbool, Gsmall, Gint, Greal, Gmp, Glg, Gvecsmall,
Gvec, Gvar, Gpol, Ggen, Ggenstr, Gstr, Gbptr, Ggptr, Gulong, Gtyp, Gnf, Gbnf, Gbnr, Gell, Gbell, Gclgp, Gprid, Ggal, Gnbtype, Gnotype, Ggc} Gtype;
typedef enum {Fseq,
	      Fmatrix,FmatrixL,FmatrixR,
	      Faffect,
	      Ffacteurmat,
	      Fmatrixelts,Fmatrixlines,
	      Fmat,Fvec,Fnoarg,
	      Flistarg,
	      Frefarg,
	      Fconst,Fsmall,
	      Ftag,
	      Fentry,Ffunction,Fderfunc,Fdeffunc,
} Ffunc;

#define Flastfunc  (Fdeffunc)
const char *Ffuncname[Flastfunc+1];
#define FneedENTRY (Fconst)

/*see parse.y for definition.
Fblock x: block number y:seq
Fgnil   : it's a noop, but if evaluated leads to 0.
*/
typedef struct node_s
{
  Ffunc f;          /*node function*/
  int x;            /*node left child*/
  int y;            /*node right child*/
  char *start;
  char *end;
} node;

typedef enum {CSTstr, CSTquote, CSTgen, CSTreal} CSTtype;

typedef struct
{
  CSTtype type;     /*type of data*/
  union value_u
  {
    const char *str;
    GEN gen;
  } val;
} value_t;

typedef enum {OPor, OPand, OPeq, OPne, OPge, OPg, OPle, OPl, OPs, OPp, OPsl, OPsr, OPmod, OPdr, OPeuc, OPd, OPm, OPpow, OPcat, OPstore, OPss, OPpp, OPse ,OPpe ,OPsle ,OPsre ,OPmode ,OPdre ,OPeuce ,OPde ,OPme, OPpl, OPn, OPnb, OPfact, OPderiv, OPtrans, OPhist, OPlength, OPnboperator} OPerator;

node *tree;
value_t *value;

int newnode(Ffunc f, int x, int y, struct node_loc*);
int newgennode(GEN g, struct node_loc*);
int newgenvalue(GEN g);
int newstringvalue(const char *s);
int newquotevalue(const char *s);
int newentry(const char *s);
int newmember(const char *s);
int newopcall(OPerator s, int x, int y, struct node_loc*);

typedef enum {OCpushlong,OCpushgen,OCpushreal,OCpushstoi,
              OCpushentryval,
              OCpop,
              OCvec,OCmat,OCcol,
              OCstoi,OCitos,OCtostr,OCvarn,OCpolx,
              OCprecreal,OCprecdl,
              OCcompo1,OCcompo2,OCcompoC,OCcompoL,
              OCnewptr,OCpushptr,OCendptr,
              OCcompo1ptr,OCcompo2ptr,OCcompoCptr,OCcompoLptr,
              OCcalllong,OCcallgen,OCcallint,OCcallvoid,OCcalluser,
              OCderivgen,OCderivuser,
              OCdeffunc,OCgetarg,OCdefaultarg,
              OCglobalvar} op_code;

void op_push(op_code o, long x);
long data_push(GEN x);
GEN getclosure(long sop, long sdat, long off);
void getcodepos(long *sop, long *sdat, long *off);

